##########################################################################################
#
# Magisk模块安装脚本
#
##########################################################################################
# 如果您需要更多的自定义，并且希望自己做所有事情
# 请在custom.sh中标注SKIPUNZIP=1
# 以跳过提取操作并应用默认权限/上下文上下文步骤。
# 请注意，这样做后，您的custom.sh将负责自行安装所有内容。
SKIPUNZIP=1
# 如果您需要调用Magisk内部的busybox，请在custom.sh中标注ASH_STANDALONE=1
ASH_STANDALONE=0
sd=/data/media/0
# 模块应该被安装到的路径 MODPATH；可以临时存储文件的路径 TMPDIR；模块的安装包(zip)的路径 ZIPFILE
# 模块安装状态，如已安装，则为true
BOOTMODE
# 已安装模块路径
MODDIR=$(echo $MODPATH | sed "s/modules_update/modules/")

####################################
# 安装
####################################
ui_print "

    ##########################################
          系统清理源自于☞乐阿兰那☜作品
             FileClear for ZW 5.2
     (💥业余爱好者水平有限，仅在自己手机测试，刷前准备
     好备份💥)  
    ##########################################
     ❌❌❌❌❌必须破解卡米！❌❌❌❌❌
     ❌❌❌❌❌必须破解卡米！❌❌❌❌❌
     ❌❌❌❌❌必须破解卡米！❌❌❌❌❌
     一个针对MIUI的crontab模块。旨在亮屏时通过执行
     Shell脚本清理微信、微博、QQ等APP缓存和垃圾文件，
     并屏蔽ad、.um、.uuid、MiPush、log等毒瘤和腾讯X5
     内核；并且定时清理电池优化白名单。
    ❤❤❤❤❤❤❤❤❤❤❤❤❤❤❤❤❤❤❤❤
     根据需要可以自己添加清理文件，
     定时时间设置在内存卡根目录"清理日志.txt"，也可
     以根据需要自己设置。
         具体设置方法百度crontab。
    ❤❤❤❤❤❤❤❤❤❤❤❤❤❤❤❤❤❤❤❤
    ##########################################


"

stop_install() {
test $BOOTMODE && { touch disable $MODDIR;ui_print "-   【提醒】检测到安装有旧版模块，已禁用！";}
abort "-   模块安装程序终止"
}
# 搜索删除非本模块的startclear.sh、startclear_service.sh qingli.sh文件
find /data/adb -type f -iname "j2.sh" -exec rm -f {} \; &>/dev/null
find /data/adb -type f -iname "startclear*.sh" -exec rm -f {} \; &>/dev/null
find /data/adb -type f -iname "qingli.sh" -exec rm -f {} \; &>/dev/null
find /data/adb -type f -iname "whtielist.sh" -exec rm -f {} \; &>/dev/null
# 将 $ZIPFILE 提取到 $MODPATH
ui_print "-   开始解压模块文件
                                            "
unzip -qo "$ZIPFILE" -x 'META-INF/*' -d $MODPATH >&2

  cat $MODPATH/mod/doze.conf > /data/media/0/doze.conf
  
  # 检测是否已破解卡米
ui_print "-   开始检测手机是否已经进行了破解卡米操作，耗时1~3分钟！"
test -z "$(which dexdump)" &&  { ui_print "-   没有dexdump命令，无法解包classes*.dex文件";stop_install;}
services_path=$(find / -type f -iname "services.jar" 2>/dev/null)
test -z "$services_path" && { ui_print "-   没有services.jar文件，无法检测是否已经破解卡米";stop_install;}
services_size=$(/system/bin/ls -l /system/framework/services.jar | cut -f5 -d ' ')
test "$services_size" -le "4000000" && { ui_print "-   services.jar小于4MB，未合并odex";stop_install;}
unzip -qo "$services_path" classes.dex classes2.dex -d $TMPDIR >&2
jckm_1=$(dexdump -d $TMPDIR/classes*.dex | grep -f $MODPATH/jckm.txt | wc -l)
test "$jckm_1" -ge "1" &&  { ui_print "-   没有事先破解卡米，模块不适用！！！";stop_install;} ||
ui_print "-   恭喜！！已实现破解卡米，模块适用！"
# 编辑相关文件
[[ $? == "0" ]] && ui_print "    =====================================
-   开始编辑清理电池优化白名单文件 "
sed -i '/^# / d' $MODPATH/mod/whitelist.sh
sed -i '3i\magisk_path=\$(magisk --path)\/.magisk\/busybox' $MODPATH/mod/whitelist.sh
sed -i '4i\export PATH=\/system\/bin:\$magisk_path:$PATH' $MODPATH/mod/whitelist.sh

[[ $? == "0" ]] && ui_print "-   开始编辑轻度清理文件 "
sed -i '/^# / d' $MODPATH/mod/startclear.sh
sed -i '3i\magisk_path=\$(magisk --path)\/.magisk\/busybox' $MODPATH/mod/startclear.sh
sed -i '4i\export PATH=\/system\/bin:\$magisk_path:$PATH' $MODPATH/mod/startclear.sh
[[ $? == "0" ]] && ui_print "-   开始编辑深度清理文件 
"
sed -i '/^# / d' $MODPATH/mod/qingli.sh
sed -i '3i\magisk_path=\$(magisk --path)\/.magisk\/busybox' $MODPATH/mod/qingli.sh
sed -i '4i\export PATH=\/system\/bin:\$magisk_path:$PATH' $MODPATH/mod/qingli.sh

[[ $? == "0" ]] && ui_print "-   编辑文件成功！  
    ====================================="
# 对SD卡中旧日志文件进行处理
nowtime=$(date +"%m%d‖%H:%M")
endtime=$(date +%s)
unset FileClear_logname
find $sd -iname "FileClear_zw_*.txt" \( -atime +2 -o -mtime +2 \) -delete &>/dev/null
FileClear_logname=清理日志.txt

sed -i "s/^FileClear_logname.*/FileClear_logname=$FileClear_logname/g" $MODPATH/mod/whitelist.sh && ui_print "-   修改优化白名单中日志文件名称变量成功！"
sed -i "s/^FileClear_logname.*/FileClear_logname=$FileClear_logname/g" $MODPATH/mod/startclear.sh && ui_print "-   修改轻度清理日志文件名称变量成功！"
sed -i "s/^FileClear_logname.*/FileClear_logname=$FileClear_logname/g" $MODPATH/contabs.sh && ui_print "-   修改contabs日志文件名称变量成功！"
sed -i "s/^FileClear_logname.*/FileClear_logname=$FileClear_logname/g" $MODPATH/mod/qingli.sh && ui_print "-   修改深度清理中日志文件名称变量成功！
"

[[ $? == "0" ]] && ui_print "-   修改日志文件成功！ 
    ====================================="
  sed -i "s/^Runwhitelisttime.*/Runwhitelisttime=$endtime/g" $MODPATH/service.sh && ui_print "-   修改service.sh中清理白名单上次执行时间变量成功！"
sed -i "s/^Runstartcleartime.*/Runstartcleartime=$endtime/g" $MODPATH/service.sh && ui_print "-   修改service.sh中轻度清理上次执行时间变量成功！"
sed -i "s/^Runqinglitime.*/Runqinglitime=$endtime/g" $MODPATH/service.sh && ui_print "-   修改service.sh中深度清理上次执行时间变量成功！
"
[[ $? == "0" ]] && ui_print "-   修改时间变量成功！ 
    ====================================="
 [[ $? == "0" ]] && ui_print "-   重启生效！！！
    ====================================="

# 修复v4.9.2中微信无法预览Word、PPT文件Bug
# 读取既有模块的版本号
find /data \( -iname "app_xwalkconfig" -o -iname "app_xwalkplugin" \) 2>/dev/null | $MODPATH/system/bin/xargs -I find_file sh -c "chattr -R -i find_file 2>/dev/null;chmod -R 777 find_file 2>/dev/null;rm -rf find_file 2>/dev/null"
rm -rf '/data/media/*' 2>/dev/null

# v3.8.9引入，修复因debug_log禁止写入而导致的Bug
# 读取既有模块的版本号
test $BOOTMODE && version_old_code=`awk -F '=' '/^versionCode/ {print $2}' /data/adb/modules/Regularfileclear/module.prop` || version_old_code="0"
version_new_code=`awk -F '=' '/^versionCode/ {print $2}' $MODPATH/module.prop`
[[ $version_old_code -ne 0 && $version_old_code -le 20210325 ]] && { ui_print "-   开始修复早前版本的Bug";chmod 777 $MODPATH/uninstall.sh;. $MODPATH/uninstall.sh;}
#################################
# 权限设置
#################################
# 对于目录(包括文件):
# set_perm_recursive  <目录>    <所有者> <用户组> <目录权限> <文件权限>
# 默认权限请勿删除
set_perm_recursive $MODPATH 0 0 0755 0644
set_perm_recursive $MODPATH/system 0 0 0775 0755
set_perm_recursive $MODPATH/system/bin 0 0 0775 0755
# 对于文件(不包括文件所在目录)
# set_perm  <文件名>            <所有者> <用户组> <文件权限>
chmod -R 775 $MODPATH/system
[[ ! -x $MODPATH/system/bin/xargs ]] && ui_print "-   system/bin文件夹授权失败"

#################################
# 删除多余文件
#################################
rm -rf $MODPATH/customize.sh $MODPATH/*.md $MODPATH/jckm.txt 2>/dev/null